<template>
  <div class="user-setting-oferta">
    <div class="row">
      <div class="col-xs-12">
        <div class="block">
          <div class="row">
            <div class="col-xs-12">
              <p class="title">
                Срок действия автоматически создаваемого договора по умолчанию
              </p>
            </div>
          </div>
          <div class="row-inputs">
            <ObInput
              :value="settings.contract && settings.contract.carrierAutoContractDurationMonths"
              label="Для перевозчиков"
              class="user-setting-oferta__input"
              placeholder="0"
              subTitle="Мес"
              @blur="update"
              @input="onInputValue('carrierAutoContractDurationMonths', $event)"
            />
            <ObInput
              :value="settings.contract && settings.contract.clientAutoContractDurationMonths"
              class="user-setting-oferta__input"
              label="Для клиентов"
              placeholder="0"
              subTitle="Мес"
              @blur="update"
              @input="onInputValue('clientAutoContractDurationMonths', $event)"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import ObInput from 'common-components/src/obComponents/obInput'
  import { mapActions, mapGetters } from 'vuex'

  const defaultValues = {
    carrierAutoContractDurationMonths: null,
    clientAutoContractDurationMonths: null
  }

  export default {
    name: 'Oferta',
    components: {
      ObInput
    },
    data() {
      return {
        settingsData: { ...defaultValues }
      }
    },
    async mounted() {
      try {
        this.getSettingsType('CONTRACT')
        await this.getSettings(this.userUuid)

        this.settingsData = this.settings?.contract || { ...defaultValues }
      } catch (e) {
        console.log(e)
      }
    },
    computed: {
      ...mapGetters({
        userUuid: 'user/participantUuid',
        settingsType: 'clicarSettings_2/settingsType',
        settings: 'clicarSettings_2/settings'
      })
    },
    methods: {
      ...mapActions({
        getSettings: 'clicarSettings_2/getSettings',
        getSettingsType: 'clicarSettings_2/getSettingsType',
        putSettings: 'clicarSettings_2/putSettings',
        setSettingValue: 'clicarSettings_2/setSettingValue'
      }),
      onInputValue (field, value) {
        let result = {
          ...(this.settings?.contract || {}),
          [field]: +value
        }

        this.setSettingValue({ path: `contract`, value: result })
      },
      async update () {
        try {
          await this.putSettings()

          this.$notification({
            type: 'system_notification_success',
            message: 'Сохранено'
          })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Не сохранено'
          })
        }
      }
    }
  }
</script>

<style scoped lang="scss">
@import "~common-components/src/static/css/mixins";

.user-setting-oferta {
  .title {
    padding: 30px 0 12px;
    @include font-mixin(16px, 20px, 600, $Grey-900, 0.4px);
  }
  .row-inputs {
    display: flex;
    margin-bottom: 14px;
  }
  .block{
    margin-bottom: 30px;
  }
  &__input {
    width: 180px;
    margin-right: 20px;
  }
}
</style>